import pygame
import random
import math


pygame.font.init()
FONTE = pygame.font.Font('arial.ttf', 20)
FONTE2 = pygame.font.Font('arial.ttf', 10)
MAX_X = 100

"""
Classe responsável por desenhar o gráfico usado para acompanhar 
a progressão do modelo
"""
class Grafico:
	def __init__(self, largura, altura):
		self.LARGURA = largura
		self.ALTURA = altura
		self.pontos = []
		self.numeracao_x = []
		self.numeracao_y = []
		self.pos_num_x = []
		self.pos_num_y = []
		self.linha_y = []
		self.pos_linha_y = []
		self.eixo_y = ((self.LARGURA/8,self.ALTURA/10),(self.LARGURA/8,(self.ALTURA/10)*8))
		self.eixo_x = ((self.LARGURA/8,(self.ALTURA/10)*8),((self.LARGURA/8)*7,(self.ALTURA/10)*8))

		self.Y_texto = "PONTUAÇÃO"
		self.Y_texto_pos = (0,0)
		self.X_texto = "NÚMERO DE PARTIDAS"
		self.X_texto_pos = (0,0)
	
	def draw(self, tela, lista, volta_completa, atualizado, tipo):
		tela.fill((255,255,255))
		# desenha os eixos x e y
		pygame.draw.lines(tela, (0, 0, 0), True, self.eixo_y, 2)
		pygame.draw.lines(tela, (0, 0, 0), True, self.eixo_x, 2)	
		# atualiza o gráfico com novos dados
		if atualizado:
			self.pontos = []
			self.numeracao_y = []
			self.numeracao_x = []
			self.pos_num_y = []
			self.pos_num_x = []
			self.linha_Y = []
			self.pos_linha_Y = []
			self.texto_linha_Y = []
			#####Gráfico tipo 0
			# limitando o número de dados para MAX_X criando um intervalo que
			# será usado para calcular a média
			intervalo = math.ceil(len(lista)/MAX_X)
			intervalo_x = math.ceil(MAX_X/25) if len(lista) >= MAX_X else math.ceil(len(lista)/25)
			soma = 0
			media = []
			# divide o espaço da tela no eixo x para o número de dados que 
			# serão mostrados
			divisao_x = (((self.LARGURA/8)*7)-self.LARGURA/8) / (len(lista)/intervalo if len(lista) >= MAX_X else len(lista))
			int_x = 0
			pos = 0
			# calcula a média dos pontos a dentro do intervalo calculado
			aux = []
			aux1 = []
			aux.append(0)
			aux1.append(self.LARGURA/8)
			for i in range(len(lista)):
				soma += lista[i]
				if i == 0 and intervalo == 1:
					media.append(lista[i])
					soma = 0
					pos += 1
				elif i%intervalo == 0 and i != 0:
					media.append(soma/intervalo)
					soma = 0
					int_x += 1
					# calcula a posição da rotulação do eixo x
					if int_x%intervalo_x == 0:
						aux.append(i)
						aux1.append(self.LARGURA/8 + divisao_x*pos)
						int_x = 0
					
					pos += 1

			if i%intervalo != 0:
				media.append(soma/(i%intervalo))
				int_x += 1
				if int_x%intervalo_x == 0:
					aux.append(i)
					aux1.append(self.LARGURA/8 + divisao_x*pos)
			
			self.numeracao_x.append(aux)
			self.pos_num_x.append(aux1)
			# divide o espaço da tela no eixo y entre os valores dos pontos
			divisao_y = (((self.ALTURA/10)*8)-(self.ALTURA/10)) / max(media)
			# calculando a posição dos pontos do gráfico
			aux = []
			for i in range(len(media)):
				aux.append((self.LARGURA/8 + divisao_x*i, ((self.ALTURA/10)*8) - divisao_y*media[i]))
			self.pontos.append(aux)
				
			# calcula a posição da rotulação do eixo y
			maximo = max(media)
			intervalo_y = math.floor(maximo/10) if maximo > 10 else 1
			aux = []
			aux1 = []
			for i in range(11):
				pos = ((self.ALTURA/10)*8) - divisao_y*i*intervalo_y
				if pos >= self.eixo_y[0][1]:
					aux.append(i*intervalo_y)
					
					aux1.append(pos)
			self.numeracao_y.append(aux)
			self.pos_num_y.append(aux1)

			# calcula a posição da linha que demontra a quantidade de voltas dadas
			i = 1
			aux = []
			aux1 = []
			aux2 = []
			while i*volta_completa < maximo:
				aux.append(i*volta_completa)
				aux1.append(((self.ALTURA/10)*8) - divisao_y*i*volta_completa)
				if i == 1:
					aux2.append(f"{i} volta")
				else:
					aux2.append(f"{i} voltas")
				i *= 10
			# gera o rótulo do eixo x baseado no valor do intervalo
			self.linha_Y.append(aux)
			self.pos_linha_Y.append(aux1)
			self.texto_linha_Y.append(aux2)
			self.X_texto = []
			if intervalo > 1:
				self.X_texto.append(f"MEDIA DO INTERVALO ENTRE {intervalo} PARTIDAS")
			else:
				self.X_texto.append("NÚMERO DE PARTIDAS")

			####Grafico tipo 1
			# Criando o intervalo de números que serão mostrados
			intervalo = MAX_X if len(lista) >= MAX_X else len(lista)
			intervalo_x = math.ceil(intervalo/25)
			desloc = len(lista) - intervalo

			# divide o espaço da tela no eixo x para o número de dados que 
			# serão mostrados
			divisao_x = (((self.LARGURA/8)*7)-self.LARGURA/8) / intervalo
			divisao_y = (((self.ALTURA/10)*8)-(self.ALTURA/10)) / max(lista[desloc-1:])
			int_x = 0
			pos = 0
			# calcula a média dos pontos a dentro do intervalo calculado
			aux = []
			aux1 = []
			aux2 = []
			aux1.append(0)
			aux2.append(self.LARGURA/8)
			for i in range(intervalo):
				aux.append((self.LARGURA/8 + divisao_x*i, ((self.ALTURA/10)*8) - divisao_y*lista[i+desloc]))
				
				if i%intervalo_x == 0:
					aux1.append(i)
					aux2.append(self.LARGURA/8 + divisao_x*i)
			
			self.pontos.append(aux)
			self.numeracao_x.append(aux1)
			self.pos_num_x.append(aux2)

			# calcula a posição da rotulação do eixo y
			maximo = max(lista[desloc-1:])
			intervalo_y = math.floor(maximo/10) if maximo > 10 else 1
			aux = []
			aux1 = []
			for i in range(11):
				pos = ((self.ALTURA/10)*8) - divisao_y*i*intervalo_y
				if pos >= self.eixo_y[0][1]:
					aux.append(i*intervalo_y)
					
					aux1.append(pos)
			self.numeracao_y.append(aux)
			self.pos_num_y.append(aux1)

			# calcula a posição da linha que demontra a quantidade de voltas dadas
			i = 1
			aux = []
			aux1 = []
			aux2 = []
			while i*volta_completa < maximo:
				aux.append(i*volta_completa)
				aux1.append(((self.ALTURA/10)*8) - divisao_y*i*volta_completa)
				if i == 1:
					aux2.append(f"{i} volta")
				else:
					aux2.append(f"{i} voltas")
				i *= 10
			# gera o rótulo do eixo x baseado no valor do intervalo
			self.linha_Y.append(aux)
			self.pos_linha_Y.append(aux1)
			self.texto_linha_Y.append(aux2)
			if intervalo == MAX_X:
				self.X_texto.append(f"ÚLTIMAS {MAX_X} PARTIDAS")
			else:
				self.X_texto.append("NÚMERO DE PARTIDAS")
			
		# desenha o gráfico

		texto = FONTE.render(self.Y_texto, True, (0,0,0))
		texto = pygame.transform.rotate(texto, 90)
		self.Y_texto_pos = [self.LARGURA/8 - texto.get_width() * 3, ((self.ALTURA/10)+((self.ALTURA/10)*8))/2 - texto.get_height()/2]
		tela.blit(texto, self.Y_texto_pos)
		texto = FONTE.render(self.X_texto[tipo], True, (0,0,0))
		self.X_texto_pos = [self.LARGURA/2 - texto.get_width()/2, self.ALTURA/10*8 + texto.get_height() * 2]	
		tela.blit(texto, self.X_texto_pos)

		for i in range(len(self.numeracao_y[tipo])):
			line_pos = [(self.LARGURA/8 - 5,self.pos_num_y[tipo][i]), (self.LARGURA/8 + 5,self.pos_num_y[tipo][i])]
			pygame.draw.lines(tela, (0, 0, 0), True, line_pos, 2)
			texto = FONTE2.render(str(self.numeracao_y[tipo][i]), True, (0,0,0))
			ponto_pos = [self.LARGURA/8-10-texto.get_width(),self.pos_num_y[tipo][i] - texto.get_height()/2]
			tela.blit(texto, ponto_pos)	


		for i in range(len(self.numeracao_x[tipo])):
			line_pos = [(self.pos_num_x[tipo][i],(self.ALTURA/10)*8-5), (self.pos_num_x[tipo][i],(self.ALTURA/10)*8+5)]
			pygame.draw.lines(tela, (0, 0, 0), True, line_pos, 2)
			texto = FONTE2.render(str(self.numeracao_x[tipo][i]), True, (0,0,0))
			ponto_pos = [self.pos_num_x[tipo][i]-texto.get_width()/2,(self.ALTURA/10)*8+texto.get_height()]
			tela.blit(texto, ponto_pos)	
		
		for i in range(len(self.linha_Y[tipo])):
			pygame.draw.line(tela, (100,100,100), (self.LARGURA/8, self.pos_linha_Y[tipo][i]), ((self.LARGURA/8)*7, self.pos_linha_Y[tipo][i]))
			texto = FONTE.render(self.texto_linha_Y[tipo][i], True, (0,0,0))
			self.X_texto_pos = ((self.LARGURA/8)*7, self.pos_linha_Y[tipo][i] - texto.get_height()/2)	
			tela.blit(texto, self.X_texto_pos)

		for i in range(len(self.pontos[tipo])-1):
			pygame.draw.lines(tela, (0,0,255), True, (self.pontos[tipo][i], self.pontos[tipo][i+1]), 2)
		