import pygame
import botao
import os
import shutil


#####CORES
COR_BASE = pygame.Color('turquoise4') 
COR_FONTE1 = pygame.Color('ivory')
COR_FONTE2 = pygame.Color('antiquewhite')
COR_FUNDO_BOTAO = pygame.Color('darkslategrey')
COR_BORDA_BOTAO = pygame.Color('grey10')
COR_BOTAO_BLOQUEADO = pygame.Color('grey25')
COR_FUNDO_CAIXA = pygame.Color('darkslategrey')
COR_BORDA_CAIXA = pygame.Color('grey10')
COR_CAIXA_SELECIONADA = pygame.Color('grey25')
COR_FUNDO_MENU = pygame.Color('steelblue4')
COR_BORDA_MENU = pygame.Color('slateblue4')
COR_SELECAO_ATIVO = pygame.Color('blue')

pygame.font.init()
FONTE = pygame.font.Font('arial.ttf', 50)
FONTE2 = pygame.font.Font('arial.ttf', 25)
FONTE3 = pygame.font.Font('arial.ttf', 35)

FPS = 60

"""
	Classe do menu do simulador
"""
class Menu():
	def __init__(self, largura, altura, numero_pistas, modelos_treinados, caminho_modelos):
		self.botoes = {}
		self.entrada_texto = {}
		self.LARGURA = largura
		self.ALTURA = altura
		self.numero_pistas = numero_pistas
		self.modelos_treinados = modelos_treinados
		self.initObjetos()
		self.janela = 0
		self.apertado = False
		self.pista = -1
		self.pista_selecionada = -1
		self.carregar_modelo = False
		self.modelo_carregar = ''
		self.modelo_criado = caminho_modelos
		self.modelos = -1
		self.digi_ativa = False
		self.substituicao = False
		self.caminhoModelos = caminho_modelos

	# inicia todos os botões e caixas de texto do menu.
	def initObjetos(self):
		####Botões
		self.botoes['iniciar'] = botao.BotaoTexto((self.LARGURA/2, 300), "INICIAR", FONTE, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, True)
		self.botoes['sair'] = botao.BotaoTexto((self.LARGURA/2, 450), "SAIR", FONTE, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, True)
		self.botoes['pistas'] = []
		posx = 190
		posy = 100
		for i in range(0, self.numero_pistas):
			img = pygame.image.load(f"imagens/pista{i+1}.jpg").convert_alpha()
			self.botoes['pistas'].append([botao.BotaoImagem((posx, posy), img, 0.2, (0,0,0), True), f'pista{i}/'])
			posx += 300
			if posx >= 1200:
				posx = 190
				posy += 200
		self.botoes['voltar'] = botao.BotaoTexto((150, self.ALTURA-55), "VOLTAR", FONTE3, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, True)
		self.botoes['continuar'] = botao.BotaoTexto((self.LARGURA/2, (self.ALTURA/8)*3), "CONTINUAR", FONTE, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, True)
		self.botoes['esc_modelo'] = botao.BotaoTexto((self.LARGURA/2, (self.ALTURA/8)*4.5), "ESCOLHER MODELO", FONTE, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, True)
		self.botoes['modelo_novo'] = botao.BotaoTexto((self.LARGURA/2, (self.ALTURA/8)*6), "NOVO MODELO", FONTE, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, True)
		self.botoes['modelo_vazio'] = botao.BotaoTexto((self.LARGURA/2, (self.ALTURA/8)*3), "CRIAR MODELO", FONTE, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, True)
		self.botoes['modelo_treinado'] = botao.BotaoTexto((self.LARGURA/2, (self.ALTURA/8)*4.5), "CARREGAR MODELO", FONTE, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, True)

		self.botoes['aceitar'] = botao.BotaoTexto(((self.LARGURA/8)*4, (self.ALTURA/8)*6.40), "ACEITAR", FONTE3, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, True)

		self.botoes['carregar'] = []
		self.botoes['lista_modelos'] = []
		posx = (self.LARGURA/8)*2
		posy = (self.ALTURA/8)*3
		for i in range(len(self.modelos_treinados)):
			ativado = len(self.modelos_treinados[i]) > 0
			self.botoes['carregar'].append(botao.BotaoTexto((posx, posy), f"PISTA {i+1}", FONTE3, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, ativado))
			posx += 300
			if posx >= (self.LARGURA/8)*6:
				posx = (self.LARGURA/8)*2
				posy += 200

			posxk = (self.LARGURA/8)*2
			posyk = (self.ALTURA/8)*3
			self.botoes['lista_modelos'].append([])
			for k in range(len(self.modelos_treinados[i])):
				self.botoes['lista_modelos'][i].append([botao.BotaoTexto((posxk, posyk), self.modelos_treinados[i][k][0], FONTE3, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, ativado), 
													self.modelos_treinados[i][k][1]])
				posxk += 300
				if posxk >= (self.LARGURA/8)*6:
					posxk = (self.LARGURA/8)*2
					posyk += 200
			
		self.botoes['substituir'] = botao.BotaoTexto(((self.LARGURA/8)*3, (self.ALTURA/8)*4.25), "SUBSTITUIR", FONTE3, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, True)
		self.botoes['cancelar'] = botao.BotaoTexto(((self.LARGURA/8)*5, (self.ALTURA/8)*4.25), "CANCELAR", FONTE3, COR_FONTE1, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_BOTAO_BLOQUEADO, True)

		###Caixas de texto
		self.entrada_texto['epsilon_inicial'] = botao.CaixaTexto(((self.LARGURA/8)*1.75, (self.ALTURA/8)*2.65), 150, 'Epsilon inicial', FONTE3, FONTE2, 0, '0.45', 10, COR_FONTE2, COR_FONTE1, COR_FUNDO_CAIXA, COR_BORDA_CAIXA, COR_CAIXA_SELECIONADA)
		self.entrada_texto['epsilon_decaimento'] = botao.CaixaTexto(((self.LARGURA/8)*4, (self.ALTURA/8)*2.65), 150, 'Decaimento do epsilon', FONTE3, FONTE2, 0, '0.9995', 10, COR_FONTE2, COR_FONTE1, COR_FUNDO_CAIXA, COR_BORDA_CAIXA, COR_CAIXA_SELECIONADA)
		self.entrada_texto['epsilon_final'] = botao.CaixaTexto(((self.LARGURA/8)*6.25, (self.ALTURA/8)*2.65), 150, 'Epsilon final', FONTE3, FONTE2, 0, '0.1', 10, COR_FONTE2, COR_FONTE1, COR_FUNDO_CAIXA, COR_BORDA_CAIXA, COR_CAIXA_SELECIONADA)

		self.entrada_texto['gamma'] = botao.CaixaTexto(((self.LARGURA/8)*1.75, (self.ALTURA/8)*3.65), 150, 'Gamma', FONTE3, FONTE2, 0, '0.9', 10, COR_FONTE2, COR_FONTE1, COR_FUNDO_CAIXA, COR_BORDA_CAIXA, COR_CAIXA_SELECIONADA)
		self.entrada_texto['taxa_aprendizado'] = botao.CaixaTexto(((self.LARGURA/8)*4, (self.ALTURA/8)*3.65), 150, 'Taxa de aprendizado', FONTE3, FONTE2, 0, '0.00075', 10, COR_FONTE2, COR_FONTE1, COR_FUNDO_CAIXA, COR_BORDA_CAIXA, COR_CAIXA_SELECIONADA)
		self.entrada_texto['camada_oculta'] = botao.CaixaTexto(((self.LARGURA/8)*6.25, (self.ALTURA/8)*3.65), 150, 'Camada oculta', FONTE3, FONTE2, 1, '256', 10, COR_FONTE2, COR_FONTE1, COR_FUNDO_CAIXA, COR_BORDA_CAIXA, COR_CAIXA_SELECIONADA)

		self.entrada_texto['nome_modelo'] = botao.CaixaTexto(((self.LARGURA/8)*1.95, (self.ALTURA/8)*4.65), 275, 'Nome do modelo', FONTE3, FONTE2, 2, 'modelo', 15, COR_FONTE2, COR_FONTE1, COR_FUNDO_CAIXA, COR_BORDA_CAIXA, COR_CAIXA_SELECIONADA)
		self.entrada_texto['tamanho_memoria'] = botao.CaixaTexto(((self.LARGURA/8)*4, (self.ALTURA/8)*4.65), 150, 'Tamanho memória', FONTE3, FONTE2, 1, '100000', 10, COR_FONTE2, COR_FONTE1, COR_FUNDO_CAIXA, COR_BORDA_CAIXA, COR_CAIXA_SELECIONADA)
		self.entrada_texto['tamanho_lote'] = botao.CaixaTexto(((self.LARGURA/8)*6.25, (self.ALTURA/8)*4.65), 150, 'Tamanho lote', FONTE3, FONTE2, 1, '2500', 10, COR_FONTE2, COR_FONTE1, COR_FUNDO_CAIXA, COR_BORDA_CAIXA, COR_CAIXA_SELECIONADA)
		
		self.entrada_texto['tamanho_menor'] = botao.CaixaTexto(((self.LARGURA/8)*2.9, (self.ALTURA/8)*5.65), 150, 'Tamanho lote menor', FONTE3, FONTE2, 1, '10', 10, COR_FONTE2, COR_FONTE1, COR_FUNDO_CAIXA, COR_BORDA_CAIXA, COR_CAIXA_SELECIONADA)
		
		self.botao_selecao = botao.BotaoSelecao(((self.LARGURA/8)*5.20, (self.ALTURA/8)*5.65), "Usar GPU", FONTE3, COR_FONTE2, COR_FUNDO_BOTAO, COR_BORDA_BOTAO, COR_SELECAO_ATIVO, COR_BOTAO_BLOQUEADO, True)

	# restaura o texto das caixas de texto.
	def resetCaixas(self):
		for caixa in self.entrada_texto.values():
			caixa.reset()

	def draw(self, win):
		win.fill(COR_BASE)
		if self.janela == 0:
			botao.DesenhaTexto(win, "ESCOLHA", FONTE, COR_FONTE1, (self.LARGURA/2,100))
			self.botoes['iniciar'].draw(win)
			self.botoes['sair'].draw(win)
		else:
			for i in range(0, self.numero_pistas):
				self.botoes['pistas'][i][0].draw(win)
			if self.janela == 1:
				self.botoes['voltar'].draw(win)
			if self.janela == 2:
				pygame.draw.rect(win, COR_FUNDO_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6))
				pygame.draw.rect(win, COR_BORDA_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6), width=5)
				botao.DesenhaTexto(win, f"Pista {self.pista_selecionada+1} selecionada", FONTE, COR_FONTE1, (self.LARGURA/2,(self.ALTURA/8)*1.5))
				self.botoes['continuar'].draw(win)
				self.botoes['esc_modelo'].draw(win)
				self.botoes['modelo_novo'].draw(win)
				self.botoes['voltar'].draw(win)
			elif self.janela == 3:
				pygame.draw.rect(win, COR_FUNDO_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6))
				pygame.draw.rect(win, COR_BORDA_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6), width=5)
				botao.DesenhaTexto(win, f"Novo Modelo", FONTE, COR_FONTE1, (self.LARGURA/2,(self.ALTURA/8)*1.5))
				self.botoes['modelo_vazio'].draw(win)
				self.botoes['modelo_treinado'].draw(win)
				self.botoes['voltar'].draw(win)
			elif self.janela == 4:
				pygame.draw.rect(win, COR_FUNDO_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6))
				pygame.draw.rect(win, COR_BORDA_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6), width=5)
				botao.DesenhaTexto(win, f"Parametros do modelo", FONTE, COR_FONTE1, (self.LARGURA/2,(self.ALTURA/8)*1.35))
				for caixa in self.entrada_texto.values():
					caixa.draw(win)
				self.botao_selecao.draw(win)
				self.botoes['aceitar'].draw(win)
				if self.substituicao:
					pygame.draw.rect(win, COR_FUNDO_MENU, ((self.LARGURA/8)*2, (self.ALTURA/8)*2.5, (self.LARGURA/8)*4, (self.ALTURA/8)*2.5))
					pygame.draw.rect(win, COR_BORDA_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6), width=5)
					botao.DesenhaTexto(win, f"Modelo já existente. Deseja substitui-lo?", FONTE3, COR_FONTE1, (self.LARGURA/2,(self.ALTURA/8)*3))
					self.botoes['substituir'].draw(win)
					self.botoes['cancelar'].draw(win)
				self.botoes['voltar'].draw(win)

			elif self.janela == 5:
				pygame.draw.rect(win, COR_FUNDO_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6))
				pygame.draw.rect(win, COR_BORDA_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6), width=5)
				botao.DesenhaTexto(win, f"Carregar modelo", FONTE, COR_FONTE1, (self.LARGURA/2,(self.ALTURA/8)*1.5))
				for it in self.botoes['carregar']:
					it.draw(win)

				self.botoes['voltar'].draw(win)
			elif self.janela == 6:
				pygame.draw.rect(win, COR_FUNDO_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6))
				pygame.draw.rect(win, COR_BORDA_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6), width=5)
				botao.DesenhaTexto(win, f"Carregar modelo", FONTE, COR_FONTE1, (self.LARGURA/2,(self.ALTURA/8)*1.5))
				for it in self.botoes['lista_modelos'][self.modelos]:
					it[0].draw(win)
				self.botoes['voltar'].draw(win)
			
			elif self.janela == 7:
				pygame.draw.rect(win, COR_FUNDO_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6))
				pygame.draw.rect(win, COR_BORDA_MENU, (self.LARGURA/8, self.ALTURA/8, (self.LARGURA/8)*6, (self.ALTURA/8)*6), width=5)
				botao.DesenhaTexto(win, f"Carregar modelo", FONTE, COR_FONTE1, (self.LARGURA/2,(self.ALTURA/8)*1.5))
				for it in self.botoes['lista_modelos'][self.pista_selecionada]:
					it[0].draw(win)
				self.botoes['voltar'].draw(win)


	def update(self, win):
		retorno = 0	
		teclas = []
		self.draw(win)
		pygame.display.update()
		for event in pygame.event.get():
			# fecha o simulador
			if event.type == pygame.QUIT:
				retorno = -1
				return retorno, None, None
			if event.type == pygame.KEYDOWN:
				if event.key == pygame.K_ESCAPE:
					retorno = -1
					return retorno, None, None
				# guarda a entrada do teclado
				elif self.digi_ativa == True:
					teclas.append(event)
		# janela inicial
		if self.janela == 0:
			if self.botoes['iniciar'].Verificar(self.apertado):
				self.janela = 1
			if self.botoes['sair'].Verificar(self.apertado):
				retorno = -1
				return retorno, None, None
		# seleção de pistas
		elif self.janela == 1:
			self.modelo_criado = ''
			for i in range(0, self.numero_pistas):
				if self.botoes['pistas'][i][0].Verificar(self.apertado):
					self.pista_selecionada = i
					self.janela = 2
					self.modelo_criado += self.botoes['pistas'][i][1]
					break
			
			if self.botoes['voltar'].Verificar(self.apertado):
				self.janela = 0
		# seleção de modelo
		elif self.janela == 2:
			if self.botoes['voltar'].Verificar(self.apertado):
				self.janela = 1
			elif self.botoes['continuar'].Verificar(self.apertado):
				retorno = 1
				cam_arq = self.caminhoModelos + self.botoes['pistas'][self.pista_selecionada][1] + "Ultmodelo"
				self.modelo_criado = LerModelo(cam_arq)
			elif self.botoes['esc_modelo'].Verificar(self.apertado):
				self.janela = 7
			elif self.botoes['modelo_novo'].Verificar(self.apertado):
				self.janela = 3
		# criar modelo
		elif self.janela == 3:
			if self.botoes['voltar'].Verificar(self.apertado):
				self.janela = 2
			elif self.botoes['modelo_vazio'].Verificar(self.apertado):
				self.janela = 4
				self.carregar_modelo = False
			elif self.botoes['modelo_treinado'].Verificar(self.apertado):
				self.janela = 5
				self.carregar_modelo = True
		# configuração do modelo
		elif self.janela == 4:
			if self.botoes['voltar'].Verificar(self.apertado):
				self.janela = 3
				self.resetCaixas()
			if self.substituicao:
				if self.botoes['substituir'].Verificar(self.apertado):
					shutil.rmtree(self.modelo_criado) 
					os.makedirs(self.modelo_criado)
					GravarArquivo(self.modelo_criado, self.entrada_texto, self.botao_selecao)
					retorno = 1
					self.substituicao = False
					self.resetCaixas()
					if self.carregar_modelo:
						shutil.copyfile(f"{self.modelo_carregar}/model.pth", f"{self.modelo_criado}/model.pth")
				if self.botoes['cancelar'].Verificar(self.apertado):
					self.substituicao = False
			else:
				if self.botoes['aceitar'].Verificar(self.apertado):
					self.modelo_criado = self.caminhoModelos + self.botoes['pistas'][self.pista_selecionada][1] + self.entrada_texto['nome_modelo'].getValor()
					if os.path.exists(self.modelo_criado):
						self.substituicao = True
					else:
						os.makedirs(self.modelo_criado)
						retorno = 1
						GravarArquivo(self.modelo_criado, self.entrada_texto, self.botao_selecao)
						if self.carregar_modelo:
							shutil.copyfile(f"{self.modelo_carregar}/model.pth", f"{self.modelo_criado}/model.pth")
						self.resetCaixas()

				texto_retorno = 0
				self.botao_selecao.Verificar(self.apertado)
				for caixa in self.entrada_texto.values():
					texto_retorno += caixa.Verificar(self.apertado, teclas, self.digi_ativa)
				if texto_retorno == 1:
					self.digi_ativa = True
				elif texto_retorno == -1:
					self.digi_ativa = False
				
		# seleção de pista par
		elif self.janela == 5:
			if self.botoes['voltar'].Verificar(self.apertado):
				self.janela = 3
				self.carregar_modelo = False
			for i in range(len(self.botoes['carregar'])):
				if self.botoes['carregar'][i].Verificar(self.apertado):
					self.janela = 6
					self.modelos = i
		# seleção do modelo para carregar
		elif self.janela == 6:
			if self.botoes['voltar'].Verificar(self.apertado):
				self.janela = 5

			for it in self.botoes['lista_modelos'][self.modelos]:
				if it[0].Verificar(self.apertado):
					self.modelo_carregar = it[1]
					self.janela = 4
					LerArquivo(f"{self.modelo_carregar}/config", self.entrada_texto)
		# escolher modelo
		elif self.janela == 7:
			if self.botoes['voltar'].Verificar(self.apertado):
				self.janela = 2
			
			for it in self.botoes['lista_modelos'][self.pista_selecionada]:
				if it[0].Verificar(self.apertado):
					modelo_escolhido = it[1]
					self.modelo_criado = modelo_escolhido
					retorno = 1

		if pygame.mouse.get_pressed()[0] and not self.apertado:
			self.apertado = True
		if not pygame.mouse.get_pressed()[0] and self.apertado:
			self.apertado = False
		

		if retorno == 1:
			return retorno, self.pista_selecionada, self.modelo_criado

		return retorno, None, None
		
# grava as configuração do modelo
def GravarArquivo(caminho_arq, caixas, selecao):
	arq = open(f"{caminho_arq}/config", "w")
	escrita = f"{caixas['nome_modelo'].getValor()},{caixas['epsilon_inicial'].getValor()},{caixas['epsilon_decaimento'].getValor()},\
{caixas['epsilon_final'].getValor()},{caixas['gamma'].getValor()},{caixas['taxa_aprendizado'].getValor()},\
{caixas['camada_oculta'].getValor()},{caixas['tamanho_memoria'].getValor()},{caixas['tamanho_lote'].getValor()},{caixas['tamanho_menor'].getValor()},\
{selecao.GetValor()}"
	arq.write(escrita)
	arq.close()

# lê o arquivo de configuração
def LerArquivo(caminho_arq, caixas):
	if os.path.exists(caminho_arq):
		arq = open(caminho_arq, 'r')
		texto = arq.read()
		if texto != None:
			pedacos = texto.split(',')
			caixas['nome_modelo'].SetValor(pedacos[0])
			caixas['epsilon_inicial'].SetValor(pedacos[1])
			caixas['epsilon_decaimento'].SetValor(pedacos[2])
			caixas['epsilon_final'].SetValor(pedacos[3])
			caixas['gamma'].SetValor(pedacos[4])
			caixas['taxa_aprendizado'].SetValor(pedacos[5])
			caixas['camada_oculta'].SetValor(pedacos[6])
			caixas['tamanho_memoria'].SetValor(pedacos[7])
			caixas['tamanho_lote'].SetValor(pedacos[8])
			caixas['tamanho_menor'].SetValor(pedacos[9])

		arq.close()

# Verifica último modelo usado
def LerModelo(caminho_arq):
	arq = open(caminho_arq, "r")
	retorno = arq.read()
	arq.close()
	return retorno
